Unit DE52R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AS08R_p, DE10R_p, AF10R_p, UTDE10_p;

procedure DE52R(F :Proc_F_DE; M :Integer; XN :Real; NX :Integer;
                var X :Array of Real; HMIN :Real; EPS :Real;
                P :Real; NXORT :Integer; var XORT :Array of Real;
                K :Integer; BULODN :Boolean; var B :Array of Real;
                var C :Array of Real; var Y :Array of Real;
                var U :Array of Real; var IRAB :Array of Integer;
                var YR :Array of Real; var RK :Array of Real;
                var T :Array of Real; var IERR :Integer);

implementation

procedure DE52R(F :Proc_F_DE; M :Integer; XN :Real; NX :Integer;
                var X :Array of Real; HMIN :Real; EPS :Real;
                P :Real; NXORT :Integer; var XORT :Array of Real;
                K :Integer; BULODN :Boolean; var B :Array of Real;
                var C :Array of Real; var Y :Array of Real;
                var U :Array of Real; var IRAB :Array of Integer;
                var YR :Array of Real; var RK :Array of Real;
                var T :Array of Real; var IERR :Integer);
var
L,ISW,I,J,M1,K1,MK :Integer;
H,XI,XF :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18;
begin
IERR := 0;
K1 := K+1;
M1 := M+1;
if ( BULODN ) 
 then K1 := K1-1;
MK := M-K;
AS08R(M,K,MK,B,YR,IRAB);
H := Sqrt(EPS);
H := Sign(Sqrt(H),XORT[NXORT-1]-XN);
XI := XN;
for L:=1 to NXORT do
 begin
  _COM52R.elm1 := False;
  XF := XORT[L-1];
  for I:=1 to K do
   begin
    DE10R(F,M,XI,YR[0+(I-1)*M],XF,HMIN,EPS,P,H,YR[0+(I-1)*M],RK,J);
    if ( J = 65 ) 
     then goto _14;
_1:
   end;
  if ( BULODN ) 
   then goto _2;
  _COM52R.elm1 := True;
  DE10R(F,M,XI,YR[0+(K1-1)*M],XF,HMIN,EPS,P,H,YR[0+(K1-1)*M],RK,J);
  if ( J = 65 ) 
   then goto _15;
_2:
  AF10R(M,K1,YR,U,T);
  XI := XF;
_3:
 end;
ISW := 0;
for L:=1 to K1 do
 begin
  for I:=1 to K do
   begin
    XI := 0.0;
    for J:=1 to M do
     begin
      XI := XI+C[(I-1)+(J-1)*K]*YR[(J-1)+(L-1)*M];
_4:
     end;
    ISW := ISW+1;
    U[(ISW-1)+0*M] := XI;
_5:
   end;
_6:
 end;
if ( BULODN ) 
 then goto _7;
ISW := ISW-K;
_7:
for I:=1 to K do
 begin
  ISW := ISW+1;
  if ( BULODN ) 
   then goto _8;
  U[(ISW-1)+0*M] := C[(I-1)+(M1-1)*K]-U[(ISW-1)+0*M];
  goto _9;
_8:
  U[(ISW-1)+0*M] := C[(I-1)+(M1-1)*K];
_9:
 end;
AS08R(K,0,K,U,C[0+0*K],IRAB);
if ( BULODN ) 
 then K1 := K1+1;
for I:=1 to M do
 begin
  for J:=1 to K do
   begin
    YR[(I-1)+(K1-1)*M] := YR[(I-1)+(K1-1)*M]+C[(J-1)+0*K]*YR[(I-1)+(J-1)*M];
_10:
   end;
 end;
H := -H;
_COM52R.elm1 := True;
T[0] := XORT[NXORT-1];
for I:=1 to M do
 begin
_11:
  Y[(I-1)+0*M] := YR[(I-1)+(K1-1)*M];
 end;
for I:=1 to NX do
 begin
  DE10R(F,M,T[0],Y[0+(I-1)*M],X[I-1],HMIN,EPS,P,H,Y[0+(I-1)*M],RK,J);
  if ( J = 65 ) 
   then goto _16;
  if ( I = NX ) 
   then goto _13;
  L := I+1;
  for J:=1 to M do
   begin
    Y[(J-1)+(L-1)*M] := Y[(J-1)+(I-1)*M];
_12:
   end;
  T[0] := X[I-1];
_13:
 end;
goto _18;
_14:
IERR := 65;
goto _17;
_15:
IERR := 66;
goto _17;
_16:
IERR := 67;
_17:
UTDE10(IERR,52);
_18:
end;

end.
